#include <iostream>
#include <string>

using std::cout;
using std::cin;
using std::endl;
using std::string;

enum min_max
{
  min,
  max
};

enum side
{
  x_min,
  y_min,
  x_max,
  y_max,
  num_sides
};

enum corner
{
  x_min_y_min,
  x_min_y_max,
  x_max_y_max,
  x_max_y_min,
  num_corners
};

struct parallelogram_connection
{
  int next_id;
  corner start;
};

struct parallelogram
{
  int squares[10][10];
  parallelogram_connection adjacents[num_sides];
};

parallelogram cube[6]=
{
  {{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 1, 1, 0, 0, 0, 0},
    {0, 0, 0, 1, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 1, 1, 1, 1, 1, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
   {{3, x_max_y_max},
    {1, x_max_y_min},
    {2, x_min_y_max},
    {4, x_max_y_max}}}
  ,
  {{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 2, 2, 0, 0, 0},
    {0, 0, 0, 0, 2, 0, 0, 2, 0, 0},
    {0, 0, 0, 2, 0, 0, 0, 2, 0, 0},
    {0, 0, 0, 0, 0, 0, 2, 0, 0, 0},
    {0, 0, 0, 0, 0, 2, 0, 0, 0, 0},
    {0, 0, 0, 0, 2, 0, 0, 0, 0, 0},
    {0, 0, 0, 2, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 2, 2, 2, 2, 2, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
   {{5, x_max_y_max},
    {2, x_max_y_min},
    {0, x_min_y_max},
    {3, x_max_y_max}}}
  ,
  {{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 3, 3, 0, 0, 0, 0},
    {0, 0, 0, 3, 0, 0, 3, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 3, 0, 0, 0},
    {0, 0, 0, 0, 0, 3, 0, 0, 0, 0},
    {0, 0, 0, 0, 3, 3, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 3, 0, 0, 0},
    {0, 0, 0, 3, 0, 0, 3, 0, 0, 0},
    {0, 0, 0, 0, 3, 3, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
   {{4, x_max_y_max},
    {0, x_max_y_min},
    {1, x_min_y_max},
    {5, x_max_y_max}}}
  ,
  {{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 4, 0, 0, 4, 0, 0, 0, 0},
    {0, 0, 4, 0, 0, 4, 0, 0, 0, 0},
    {0, 0, 4, 0, 0, 4, 0, 0, 0, 0},
    {0, 0, 4, 4, 4, 4, 4, 4, 0, 0},
    {0, 0, 0, 0, 0, 4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
   {{0, x_max_y_max},
    {4, x_max_y_min},
    {5, x_min_y_max},
    {1, x_max_y_max}}}
  ,
  {{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 5, 5, 5, 5, 5, 0, 0},
    {0, 0, 0, 5, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 5, 5, 5, 5, 0, 0, 0},
    {0, 0, 0, 5, 0, 0, 0, 5, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 5, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 5, 0, 0},
    {0, 0, 0, 5, 0, 0, 0, 5, 0, 0},
    {0, 0, 0, 0, 5, 5, 5, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
   {{2, x_max_y_max},
    {5, x_max_y_min},
    {3, x_min_y_max},
    {0, x_max_y_max}}}
  ,
  {{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 6, 6, 6, 0, 0, 0},
    {0, 0, 0, 6, 0, 0, 0, 6, 0, 0},
    {0, 0, 0, 6, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 6, 0, 6, 6, 0, 0, 0},
    {0, 0, 0, 6, 6, 0, 0, 6, 0, 0},
    {0, 0, 0, 6, 0, 0, 0, 6, 0, 0},
    {0, 0, 0, 6, 0, 0, 0, 6, 0, 0},
    {0, 0, 0, 0, 6, 6, 6, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
   {{1, x_max_y_max},
    {3, x_max_y_min},
    {4, x_min_y_max},
    {2, x_max_y_max}}}
};

parallelogram current;

corner operator+(const corner lhs, const int rhs)
  {
    corner foo= lhs;
    if(rhs > 0)
    {
      for(int baz= rhs; baz > 0; --baz)
      {
        switch(foo)
        {
          case x_min_y_min:
            foo= x_min_y_max;
            break;
          case x_min_y_max:
            foo= x_max_y_max;
            break;
          case x_max_y_max:
            foo= x_max_y_min;
            break;
          case x_max_y_min:
            foo= x_min_y_min;
            break;
          default:
            return foo;
        }
      }
      return foo;
    }
    if(rhs < 0)
    {
      for(int baz= rhs; baz < 0; ++baz)
      {
        switch(foo)
        {
          case x_min_y_min:
            foo= x_max_y_min;
            break;
          case x_min_y_max:
            foo= x_min_y_min;
            break;
          case x_max_y_max:
            foo= x_min_y_max;
            break;
          case x_max_y_min:
            foo= x_max_y_max;
            break;
          default:
            return foo;
        }
      }
    }
    return foo;
  }

parallelogram_connection rotate_connection(const parallelogram_connection foo
  , int amount)
  {
    parallelogram_connection tmp;
    tmp.next_id= foo.next_id;
    tmp.start= foo.start + amount;
    return tmp;
  }

void load_current(parallelogram_connection load_from)
  {
    switch(load_from.start)
    {
      case x_min_y_min:
        for(int ix= 0, ox= 0; ox < 10; ++ix, ++ox)
        {
          for(int iy= 0, oy= 0; oy < 10; ++iy, ++oy)
          {
            current.squares[ox][oy]= cube[load_from.next_id].squares[ix][iy];
          }
        }
        current.adjacents[x_min]= cube[load_from.next_id].adjacents[x_min];
        current.adjacents[y_min]= cube[load_from.next_id].adjacents[y_min];
        current.adjacents[x_max]= cube[load_from.next_id].adjacents[x_max];
        current.adjacents[y_max]= cube[load_from.next_id].adjacents[y_max];
        break;
      case x_min_y_max:
        for(int iy= 0, ox= 0; ox < 10; ++iy, ++ox)
        {
          for(int ix= 9, oy= 0; oy < 10; --ix, ++oy)
          {
            current.squares[ox][oy]= cube[load_from.next_id].squares[ix][iy];
          }
        }
        current.adjacents[x_min]=
          rotate_connection(cube[load_from.next_id].adjacents[y_min], 1);
        current.adjacents[y_min]=
          rotate_connection(cube[load_from.next_id].adjacents[x_max], 1);
        current.adjacents[x_max]=
          rotate_connection(cube[load_from.next_id].adjacents[y_max], 1);
        current.adjacents[y_max]=
          rotate_connection(cube[load_from.next_id].adjacents[x_min], 1);
        break;
      case x_max_y_max:
        for(int ix= 9, ox= 0; ox < 10; --ix, ++ox)
        {
          for(int iy= 9, oy= 0; oy < 10; --iy, ++oy)
          {
            current.squares[ox][oy]= cube[load_from.next_id].squares[ix][iy];
          }
        }
        current.adjacents[x_min]=
          rotate_connection(cube[load_from.next_id].adjacents[x_max], 2);
        current.adjacents[y_min]=
          rotate_connection(cube[load_from.next_id].adjacents[y_max], 2);
        current.adjacents[x_max]=
          rotate_connection(cube[load_from.next_id].adjacents[x_min], 2);
        current.adjacents[y_max]=
          rotate_connection(cube[load_from.next_id].adjacents[y_min], 2);
        break;
      case x_max_y_min:
        for(int iy= 9, ox= 0; ox < 10; --iy, ++ox)
        {
          for(int ix= 0, oy= 0; oy < 10; ++ix, ++oy)
          {
            current.squares[ox][oy]= cube[load_from.next_id].squares[ix][iy];
          }
        }
        current.adjacents[x_min]=
          rotate_connection(cube[load_from.next_id].adjacents[y_max], 3);
        current.adjacents[y_min]=
          rotate_connection(cube[load_from.next_id].adjacents[x_min], 3);
        current.adjacents[x_max]=
          rotate_connection(cube[load_from.next_id].adjacents[y_min], 3);
        current.adjacents[y_max]=
          rotate_connection(cube[load_from.next_id].adjacents[x_max], 3);
        break;
      default:
        cout << "Dude, you're supposed to filter out the bogus stuff." << endl;
        return;
        break;
    }
  }

side get_move()
  {
    string s;
    cout << "What direction do you wish to move?  (up/right/down/left)" << endl;
    cin >> s;
    if(s.find("up") != string::npos)
    {
      return y_max;
    }
    if(s.find("right") != string::npos)
    {
      return x_max;
    }
    if(s.find("down") != string::npos)
    {
      return y_min;
    }
    if(s.find("left") != string::npos)
    {
      return x_min;
    }
    if(s.find("adjacent") != string::npos)
    {
      if(s.find('0') != string::npos)
      {
        cout << current.adjacents[0].next_id << endl << current.adjacents[0].start
          << endl;
      }
      if(s.find('1') != string::npos)
      {
        cout << current.adjacents[1].next_id << endl << current.adjacents[1].start
          << endl;
      }
      if(s.find('2') != string::npos)
      {
        cout << current.adjacents[2].next_id << endl << current.adjacents[2].start
          << endl;
      }
      if(s.find('3') != string::npos)
      {
        cout << current.adjacents[3].next_id << endl << current.adjacents[3].start
          << endl;
      }
      return get_move();
    }
    cout << "I'm thinking the same thing." << endl;
    return num_sides;
  }

void execute_move(side move_dir)
  {
    load_current(current.adjacents[move_dir]);
  }

void display_current()
  {
    for(int x= 0; x < 10; ++x)
    {
      for(int y= 0; y < 10; ++y)
      {
        cout << current.squares[x][y];
      }
      cout << endl;
    }
  }

void init()
  {
    parallelogram_connection foo= {0, x_min_y_min};
    load_current(foo);
    cout << "Welcome to cube world.  Enjoy your stay, and please, don't get lost." << endl;
  }

int main()
  {
    side foo;
    init();
    while(1)
    {
      display_current();
      foo= get_move();
      if(foo == num_sides)
      {
        cout << "Good bye." << endl;
        return 0;
      }
      execute_move(foo);
    }
    return 0;
  }
